/*
 * Copyright (C) 2000-2001 Chris Ross and Evan Webb
 * Copyright (C) 1999-2000 Chris Ross
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *   
 * The above copyright notice and this permission notice shall be included in
 * all copies of the Software, its documentation and marketing & publicity 
 * materials, and acknowledgment shall be given in the documentation, materials
 * and software packages that this Software was used.
 *    
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
#ifndef __FERITE_MODULE_H__
#define __FERITE_MODULE_H__

#ifdef WIN32
#define DIRDLIM  '\\'
#else
#define DIRDLIM  '/'
#endif

#define __ferite_sys_lib_ext     ".so"

FeriteModule *__ferite_create_module( char *name, char *filename );
void __ferite_destroy_module_list( FeriteModule *mod );
void __ferite_init_module_list();
void __ferite_deinit_module_list();
void __ferite_load_module( FeriteScript *script, FeriteNamespace *ns, char *name );
char **__ferite_list_modules( int *num_ret );
char **__ferite_trim_module_list( char **list, int *num);

int __ferite_lib_init(void);
void __ferite_lib_deinit(void);
void *__ferite_lib_open(const char *file);
void *__ferite_lib_openext(const char *file);
void *__ferite_lib_sym(void *h, const char *f);
int __ferite_lib_close(void *h);
const char *__ferite_lib_error(void);

#endif /* __FERITE_MODULE_H__ */
